package es.us.ccia.dummy.dibujo;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionListener;


@SuppressWarnings("serial")
public class BarraIconos extends JToolBar implements I_Constantes {

	/**
	 * 
	 */
	JButton newButton,openButton,saveButton,saveasButton;
	JButton importButton,exportButton;
	JButton undoButton,redoButton,applyButton;
	JButton reteButton;
	
	/***
	 * 
	 */
	boolean sugerencia = false;
	int     TipoAplicacion;
	
	/**
	 * Constructor de la barra de iconos
	 */
	public BarraIconos(ActionListener aL, int _tipo) {
		
		TipoAplicacion = _tipo;
		
		/*****JToolBar*****/
		//Crea los botones asignando sendas imágenes y los agrega al toolbar

		
		newButton = new JButton();
		newButton.setIcon(new ImageIcon("imagenes/nuevo.png"));		
		newButton.setMargin(new Insets(0, 0, 0, 0));
		newButton.setToolTipText("New");
		newButton.setActionCommand("New");
		newButton.addActionListener(aL);
		
		add(newButton);
		

		
		
		openButton = new JButton();
		openButton.setIcon(new ImageIcon("imagenes/abrir.png"));		
		openButton.setMargin(new Insets(0, 0, 0, 0));
		openButton.setToolTipText("Open");
		openButton.setActionCommand("Open");
		openButton.addActionListener(aL);
		add(openButton);
		

		saveButton = new JButton();
		saveButton.setIcon(new ImageIcon("imagenes/grabar.png"));
		saveButton.setMargin(new Insets(0, 0, 0, 0));
		saveButton.setToolTipText("Save");
		saveButton.setActionCommand("Save");
		saveButton.addActionListener(aL);
		add(saveButton);
		
		saveasButton = new JButton();
		saveasButton.setIcon(new ImageIcon("imagenes/grabarcomo.png"));
		saveasButton.setMargin(new Insets(0, 0, 0, 0));
		saveasButton.setToolTipText("Save as..");
		saveasButton.setActionCommand("Save as");
		saveasButton.addActionListener(aL);
		add(saveasButton);
		
		//agrega un separador en la toolbar
		addSeparator();
		
		importButton = new javax.swing.JButton();
		importButton.setIcon(new ImageIcon("imagenes/importar.png"));
		importButton.setMargin(new Insets(0, 0, 0, 0));
		importButton.setToolTipText("Import from Delicious");
		importButton.setActionCommand("Import Delic");
		importButton.addActionListener(aL);
		add(importButton);
		
		exportButton = new javax.swing.JButton();
		exportButton.setIcon(new ImageIcon("imagenes/exportar.png"));
		exportButton.setMargin(new Insets(0, 0, 0, 0));
		exportButton.setToolTipText("Export to Delicious");
		exportButton.setActionCommand("Export Delic");
		exportButton.addActionListener(aL);
		add(exportButton);

		
		//agrega un separador en la toolbar
		addSeparator();
		
		undoButton = new javax.swing.JButton();
		undoButton.setIcon(new ImageIcon("imagenes/undo.png"));
		undoButton.setMargin(new Insets(0, 0, 0, 0));
		undoButton.setToolTipText("Undo movements");
		undoButton.setActionCommand("undo");
		undoButton.addActionListener(aL);
		add(undoButton);
		
		redoButton = new javax.swing.JButton();
		redoButton.setIcon(new ImageIcon("imagenes/redo.png"));
		redoButton.setMargin(new Insets(0, 0, 0, 0));
		redoButton.setToolTipText("Redo movements");
		redoButton.setActionCommand("redo");
		redoButton.addActionListener(aL);
		add(redoButton);
		
		//agrega un separador en la toolbar
		addSeparator();

		
		applyButton = new javax.swing.JButton();
		applyButton.setIcon(new ImageIcon("imagenes/aplicar.png"));
		applyButton.setMargin(new Insets(0, 0, 0, 0));
		applyButton.setToolTipText("Apply changes");
		applyButton.setActionCommand("apply");
		applyButton.addActionListener(aL);
		add(applyButton);

		
    	if (TipoAplicacion == TINY) {    		

		//agrega un separador en la toolbar
		addSeparator();
		
		
		reteButton = new javax.swing.JButton();
		reteButton.setIcon(new ImageIcon("imagenes/sugerencias.png"));
		reteButton.setMargin(new Insets(0, 0, 0, 0));
		reteButton.setToolTipText("Make suggestions");
		reteButton.setActionCommand("suggest");
		reteButton.addActionListener(aL);
		
		if (!sugerencia)
			reteButton.setBackground(Color.BLACK);
		else
			reteButton.setBackground(Color.RED);
		
		add(reteButton);
		
		
    	}
		
		
		
	}
	
	public void cambiarSugerencias() {
		setSugerencias(!sugerencia);
	}
	
	
	public void setSugerencias(boolean _sug) {

		if (TipoAplicacion == TINY) {    		
			this.sugerencia = _sug;
			if (!this.sugerencia)
				reteButton.setBackground(Color.BLACK);
			else
				reteButton.setBackground(Color.RED);
		}		
	}
	
	
}
