package es.us.ccia.dummy.dibujo.eventos;

/**
 * Version 0.9: 
 *    20080713
 *    - Clase que realiza todos los movimientos sobre 
 *      el dibujo.
 *       
 *==================================================
 * TODO: Revisar por que se pone uno en azul que no 
 *       corresponde. 
 *     - Hay un fallo, cuando se selecciona el primero 
 *       de la lista de relaciones... luego no funciona
 *       el movimiento sobre las regiones 
 * 
 */

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Set;
import java.util.Stack;

import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;

import es.us.ccia.dummy.dibujo.ventanas.VentanaDibujo;
import es.us.ccia.dummy.dibujo.GUI;
import es.us.ccia.dummy.teoria.regiones.*;
import es.us.tad.Salida;


/***
 * 
 * @author  Gonzalo A. Aranda Corral
 * @version 0.9.0
 * @since   13/07/2008
 *
 */
@SuppressWarnings({"unchecked"})
public class Movimientos implements MouseListener, MouseMotionListener, I_Elemento {
	int BotonActivo;  // Boton pulsado
	int mposX;
	int mposY;

	int mancho;
	int malto;
	boolean    marcado;

	boolean    modificado;
	
	Elemento   activo;      // Elemento activo o pinchado
	Elemento   iluminado; 
	
	ListaElementos historial;
	ListaElementos ListaE;
	
	GUI gui = null;
	
	Stack PilaE = null;

	
	/**
	 * Constructor de la clase
	 * @param g Enlace con el entorno grafico
 	*/
	public Movimientos(GUI g, ListaElementos _le) {
		// INICIALIZACION		
		activo = null;
		iluminado = null;
		BotonActivo = -1;
		mposX = -1;
		mposY = -1;
		marcado = false;
		modificado = false;
		ListaE = _le;
		gui = g;
		PilaE = new Stack();
	}

	public void actualizar(ListaElementos _le) {
		ListaE = _le;
//		System.out.println(ListaE.toString());
		PilaE = new Stack();
		PilaE.push(_le.clone());
	}
	
	public void deshacer() {
		Salida.Imprimirln("en el raton tambien se hace algo.");
		
		ListaE = (ListaElementos)PilaE.pop();
		
//		arg0.getComponent().repaint();

		
		gui.repintarDibujo();
		
		activo = null;
		BotonActivo = -1;
		mposX = -1;   // Posicion del raton al arrastrar
		mposY = -1;

		gui.cambioVentanaDibujo(ListaE);
		
	}
	
	
	

	/***
	 * Procedimiento donde se activa una region
	 */
	public void mousePressed(MouseEvent arg0) {
		
		if (ListaE != null) {

			BotonActivo = arg0.getButton();
			mposX = arg0.getX();
			mposY = arg0.getY();

	        Iterator e = ListaE.iterator();
	        while (e.hasNext()) {
	        	Elemento rr = (Elemento)e.next();
	        	if (rr.pertenece(arg0.getX(), arg0.getY())) {
	        		activo = rr;
	        	}
	        }
	        
		} else {
			Salida.Imprimirln("La lista es nula");	
		}
		
	}


	/***
	 * Procedimiento para SOLTAR una region
	 */
	public void mouseReleased(MouseEvent arg0) {
		
		if (activo != null) {
			modificado = true;

			if (BotonActivo == MouseEvent.BUTTON1) {
				int coordx = activo.getX1();
				int coordy = activo.getY1();
				
				// AJUSTE A LA CUADRICULA
				if (coordx % 10 > 5 ) {
					coordx = coordx + 10 - coordx % 10;
				} else {
					coordx = coordx - coordx % 10;
				}
				if (coordy % 10 > 5 ) {
					coordy = coordy + 10 - coordy % 10;
				} else {
					coordy = coordy - coordy % 10;
				}
				activo.posicionar(coordx, coordy);
				
				PilaE.push(ListaE.clone());
				
				
				
			} else if (BotonActivo == MouseEvent.BUTTON3) {

				if (activo.getTipo() == REGION) {

					Region rr = (Region)activo;
					int ancho = rr.getAncho();
					int alto  = rr.getAlto();
					
					//  AJUSTE A LA CUADRICULA
					int sobra = ancho % 10; 
					if (sobra > 5) {
						ancho = ancho - sobra + 10;
					} else {
						ancho = ancho - sobra;
					}
					sobra = alto % 10;
					if (sobra > 5) {
						alto = alto - sobra + 10;
					} else {
						alto = alto - sobra;
					}
					rr.actualizar(ancho, alto);
					PilaE.push(ListaE.clone());
				}
			}
		} else {
			
//			System.out.println("el popup");
			
			
			JPopupMenu popup = new JPopupMenu();
			popup.setName("Gonzalo");

		    JMenuItem elemento = new JMenuItem( "List indivuals of..." );
//		    elemento.addActionListener( al );
		    popup.add( elemento );

		    popup.addSeparator();

		    
//		    Hay que hacerlo de otra manera
		    
		    ArrayList ListaM = new ArrayList(); 
		    
		    
        	Iterator e1 = ListaE.iterator();
        	while (e1.hasNext()) {
        		Elemento rr = (Elemento)e1.next();
        		if (rr.getTipo() == REGION) {
        			Region re = (Region)rr;
        			if (re.contiene(arg0.getX(), arg0.getY())) {
        				ListaM.add(rr.getNombre());
        			}
        		}
        	}

        	
	        if (ListaM.size() >1) {
	        	elemento = new JMenuItem( "All classes" );
//			    elemento.addActionListener( al );
	        	popup.add( elemento );
	        }		    
		    
		    
        	Iterator e2 = ListaM.iterator();
        	while (e2.hasNext()) {
        		String cadena= (String)e2.next();
				elemento = new JMenuItem(cadena);
//				elemento.addActionListener( al );
        		popup.add( elemento );
        	}
		    
		    
	        
	        
		    if (BotonActivo == MouseEvent.BUTTON3) {
			    popup.show( arg0.getComponent(),arg0.getX(),arg0.getY() );
			}

			
			
			
			
			
			

			
			
			
			
			
			
			
			
			
		}

		
		arg0.getComponent().repaint();
		activo = null;
		BotonActivo = -1;
		mposX = -1;   // Posicion del raton al arrastrar
		mposY = -1;

		gui.cambioVentanaDibujo(ListaE);
		
	}

	/***
	 * Procedimiento para ARRASTRAR una region
	 */
	public void mouseDragged(MouseEvent arg0) {

		if (activo != null) {			
			int nuevaX = arg0.getX();
			int nuevaY = arg0.getY();
			
			if (BotonActivo == MouseEvent.BUTTON1) {
				int cx = activo.getX1() + (nuevaX-mposX);
				int cy = activo.getY1() + (nuevaY-mposY);
				
				if (cx<0) cx = 0;  if (cy<0) cy = 0;
				if (cx>VentanaDibujo.TAMANOX) cx = VentanaDibujo.TAMANOX;
				if (cy>VentanaDibujo.TAMANOY) cy = VentanaDibujo.TAMANOY;
				
				activo.posicionar( cx , cy );
				
			} else if (BotonActivo == MouseEvent.BUTTON3) {
				if (activo.getTipo() == REGION) {
					Region rr = (Region)activo;
					int cx = rr.getAncho() + (nuevaX-mposX);
					int cy = rr.getAlto() + (nuevaY-mposY);
					if (cx<30) cx = 30;  if (cy<30) cy = 30;
					rr.actualizar(cx, cy);
				}
			}
			mposX = nuevaX;
			mposY = nuevaY;

		}

		// Aqui se puede hacer lo del UNDO
//		gui.getAreaDibujo().repaint();
		gui.repintarDibujo();
		
		
	}




	/***
	 * Procedimiento para RESALTAR una region cuando paso por encima
	 */
	public void mouseMoved(MouseEvent arg0) {
		
		// Aqui guardaré las regiones que voy acumulando
		Set listaRegiones = new HashSet();
		
		if (ListaE != null) {
	        Iterator e = ListaE.iterator();
	        while (e.hasNext()) {
	        	Elemento rr = (Elemento)e.next();
	        	if (rr.esFrontera(arg0.getX(), arg0.getY())) {
	        		rr.seleccionar(true);
	        		listaRegiones.add(rr.getNombre());
	        	} else {
	        		rr.seleccionar(false);
	        	}
	        }
		}
		gui.repintarDibujo();


	
	}


	public void mouseClicked(MouseEvent arg0) {
	}
	public void mouseEntered(MouseEvent arg0) {
	}
	public void mouseExited(MouseEvent arg0) {
	}


	public boolean estaModificado() {
		return this.modificado;
	}

	public void setModificado(boolean m) {
		this.modificado = m;
	}


}
