package es.us.ccia.dummy.dibujo.ventanas;

import java.awt.*;
import java.util.*;
import javax.swing.*;

import es.us.ccia.dummy.dibujo.GUI;
import es.us.ccia.dummy.dibujo.eventos.EventosClases;

/***
 * 
 * @author  Gonzalo A. Aranda Corral
 * @version 0.1.0
 * @since   28/02/2009
 * @see
 *    20090228 Carga de las etiquetas del usuario 
 * 
 *
 */   
@SuppressWarnings({"serial","unchecked"})
public class VentanaEtiquetas extends JComponent {
    
	JList lista;
	DefaultListModel Lmodelo;
	JScrollPane panelCls;
    
   
	public VentanaEtiquetas(GUI g) {
		super();

		lista   = new JList();
		lista.setCellRenderer(new ClasesRenderer());
    	Lmodelo = new DefaultListModel();
    	lista.setModel(Lmodelo);
    	
        lista.addListSelectionListener(new EventosClases(g));

    	reiniciar(null);

    	panelCls = new JScrollPane(lista);

        setLayout(new BorderLayout());
        add(panelCls,BorderLayout.CENTER);
        
	}
		
	
	public void reiniciar(Collection lista) {
		
		if (lista != null) {

			Set orden = new TreeSet(); 
			
			Lmodelo.clear();
	
	    	for (Iterator i= lista.iterator();i.hasNext();) {
	    		ElementoLista cl = 
	    			new ElementoLista((i.next()).toString(),true);
	    		orden.add(cl);
	    	}
	    	
	    	Iterator i = orden.iterator();
	    	while (i.hasNext())
	    		Lmodelo.addElement(i.next());
	    	
	//    	lista.setSelectedValue(null, false);
		}
	}

	
	public ArrayList getSeleccion() {
		
		ArrayList devolver = new ArrayList();
//		int tamano = lista.getSelectedIndices().length;
//		
//		for(int indice=0;indice<tamano;indice++) {
//			
//			String cadena = lista.getSelectedValues()[indice].toString(); 
//			Salida.Imprimirln(cadena);
//			
//			
//			FCAAttribute clase = Contexto.getAttribute(cadena);
//			devolver.add(clase);
//		}
//		
		return devolver;
	}
	
	public void addClase(String clase) {
		ElementoLista cl = new ElementoLista(clase,true);
		Lmodelo.addElement(cl);
	}

	
	
	
}

/***********************************************
 * 
 * 
 * @author garanda
 *
 */

@SuppressWarnings("serial")
class ClasesRenderer extends JLabel implements ListCellRenderer {
 
private static final Color HIGHLIGHT_COLOR = new Color(0, 0, 128);

  public ClasesRenderer() {
    setOpaque(true);
    setIconTextGap(12);
  }

  public Component getListCellRendererComponent(JList list, Object value,
      int index, boolean isSelected, boolean cellHasFocus) {
	  ElementoLista entry = (ElementoLista) value;
	  
//	  setIcon(Icons.getClsIcon());
	  setText(entry.getNombre());

	setBackground(Color.white);
	setForeground(Color.black);
    
    if (isSelected) {
    	if (entry.getConsistente()) {
			setBackground(HIGHLIGHT_COLOR);
			setForeground(Color.white);
        	this.setFont(new Font("Default",Font.BOLD,12));
    	} else {
    		setForeground(Color.white);
    		setBackground(Color.red);
        	this.setFont(new Font("Default",Font.BOLD,12));
    	}
    	
    } else {
		setBackground(Color.white);
		setForeground(Color.black);
    	if (entry.getConsistente()) {
    		this.setFont(new Font("Default",Font.PLAIN,12));	
    	} else {
    		setForeground(Color.red);
        	this.setFont(new Font("Default",Font.BOLD,12));
    	}
    	
    }
    return this;
  }
}
